```python
#librairies et classes de calcul
import numpy
import os
import pandas
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import train_test_split

#changer de dossier
os.chdir("C:/Users/Zatovo/Desktop/demo")

#charger les données
D = pandas.read_table("covertype.txt")
D.info()
```

    <class 'pandas.core.frame.DataFrame'>
    RangeIndex: 581012 entries, 0 to 581011
    Data columns (total 55 columns):
     #   Column  Non-Null Count   Dtype 
    ---  ------  --------------   ----- 
     0   V1      581012 non-null  int64 
     1   V2      581012 non-null  int64 
     2   V3      581012 non-null  int64 
     3   V4      581012 non-null  int64 
     4   V5      581012 non-null  int64 
     5   V6      581012 non-null  int64 
     6   V7      581012 non-null  int64 
     7   V8      581012 non-null  int64 
     8   V9      581012 non-null  int64 
     9   V10     581012 non-null  int64 
     10  V11     581012 non-null  int64 
     11  V12     581012 non-null  int64 
     12  V13     581012 non-null  int64 
     13  V14     581012 non-null  int64 
     14  V15     581012 non-null  int64 
     15  V16     581012 non-null  int64 
     16  V17     581012 non-null  int64 
     17  V18     581012 non-null  int64 
     18  V19     581012 non-null  int64 
     19  V20     581012 non-null  int64 
     20  V21     581012 non-null  int64 
     21  V22     581012 non-null  int64 
     22  V23     581012 non-null  int64 
     23  V24     581012 non-null  int64 
     24  V25     581012 non-null  int64 
     25  V26     581012 non-null  int64 
     26  V27     581012 non-null  int64 
     27  V28     581012 non-null  int64 
     28  V29     581012 non-null  int64 
     29  V30     581012 non-null  int64 
     30  V31     581012 non-null  int64 
     31  V32     581012 non-null  int64 
     32  V33     581012 non-null  int64 
     33  V34     581012 non-null  int64 
     34  V35     581012 non-null  int64 
     35  V36     581012 non-null  int64 
     36  V37     581012 non-null  int64 
     37  V38     581012 non-null  int64 
     38  V39     581012 non-null  int64 
     39  V40     581012 non-null  int64 
     40  V41     581012 non-null  int64 
     41  V42     581012 non-null  int64 
     42  V43     581012 non-null  int64 
     43  V44     581012 non-null  int64 
     44  V45     581012 non-null  int64 
     45  V46     581012 non-null  int64 
     46  V47     581012 non-null  int64 
     47  V48     581012 non-null  int64 
     48  V49     581012 non-null  int64 
     49  V50     581012 non-null  int64 
     50  V51     581012 non-null  int64 
     51  V52     581012 non-null  int64 
     52  V53     581012 non-null  int64 
     53  V54     581012 non-null  int64 
     54  TYPE    581012 non-null  object
    dtypes: int64(54), object(1)
    memory usage: 243.8+ MB
    


```python
#description
D.describe()
```




<div>
<style scoped>
    .dataframe tbody tr th:only-of-type {
        vertical-align: middle;
    }

    .dataframe tbody tr th {
        vertical-align: top;
    }

    .dataframe thead th {
        text-align: right;
    }
</style>
<table border="1" class="dataframe">
  <thead>
    <tr style="text-align: right;">
      <th></th>
      <th>V1</th>
      <th>V2</th>
      <th>V3</th>
      <th>V4</th>
      <th>V5</th>
      <th>V6</th>
      <th>V7</th>
      <th>V8</th>
      <th>V9</th>
      <th>V10</th>
      <th>...</th>
      <th>V45</th>
      <th>V46</th>
      <th>V47</th>
      <th>V48</th>
      <th>V49</th>
      <th>V50</th>
      <th>V51</th>
      <th>V52</th>
      <th>V53</th>
      <th>V54</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>count</th>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>...</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
      <td>581012.000000</td>
    </tr>
    <tr>
      <th>mean</th>
      <td>2959.365301</td>
      <td>155.656807</td>
      <td>14.103704</td>
      <td>269.428217</td>
      <td>46.418855</td>
      <td>2350.146611</td>
      <td>212.146049</td>
      <td>223.318716</td>
      <td>142.528263</td>
      <td>1980.291226</td>
      <td>...</td>
      <td>0.044175</td>
      <td>0.090392</td>
      <td>0.077716</td>
      <td>0.002773</td>
      <td>0.003255</td>
      <td>0.000205</td>
      <td>0.000513</td>
      <td>0.026803</td>
      <td>0.023762</td>
      <td>0.015060</td>
    </tr>
    <tr>
      <th>std</th>
      <td>279.984734</td>
      <td>111.913721</td>
      <td>7.488242</td>
      <td>212.549356</td>
      <td>58.295232</td>
      <td>1559.254870</td>
      <td>26.769889</td>
      <td>19.768697</td>
      <td>38.274529</td>
      <td>1324.195210</td>
      <td>...</td>
      <td>0.205483</td>
      <td>0.286743</td>
      <td>0.267725</td>
      <td>0.052584</td>
      <td>0.056957</td>
      <td>0.014310</td>
      <td>0.022641</td>
      <td>0.161508</td>
      <td>0.152307</td>
      <td>0.121791</td>
    </tr>
    <tr>
      <th>min</th>
      <td>1859.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>-173.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>...</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
    </tr>
    <tr>
      <th>25%</th>
      <td>2809.000000</td>
      <td>58.000000</td>
      <td>9.000000</td>
      <td>108.000000</td>
      <td>7.000000</td>
      <td>1106.000000</td>
      <td>198.000000</td>
      <td>213.000000</td>
      <td>119.000000</td>
      <td>1024.000000</td>
      <td>...</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
    </tr>
    <tr>
      <th>50%</th>
      <td>2996.000000</td>
      <td>127.000000</td>
      <td>13.000000</td>
      <td>218.000000</td>
      <td>30.000000</td>
      <td>1997.000000</td>
      <td>218.000000</td>
      <td>226.000000</td>
      <td>143.000000</td>
      <td>1710.000000</td>
      <td>...</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
    </tr>
    <tr>
      <th>75%</th>
      <td>3163.000000</td>
      <td>260.000000</td>
      <td>18.000000</td>
      <td>384.000000</td>
      <td>69.000000</td>
      <td>3328.000000</td>
      <td>231.000000</td>
      <td>237.000000</td>
      <td>168.000000</td>
      <td>2550.000000</td>
      <td>...</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
      <td>0.000000</td>
    </tr>
    <tr>
      <th>max</th>
      <td>3858.000000</td>
      <td>360.000000</td>
      <td>66.000000</td>
      <td>1397.000000</td>
      <td>601.000000</td>
      <td>7117.000000</td>
      <td>254.000000</td>
      <td>254.000000</td>
      <td>254.000000</td>
      <td>7173.000000</td>
      <td>...</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
      <td>1.000000</td>
    </tr>
  </tbody>
</table>
<p>8 rows × 54 columns</p>
</div>




```python
#distribution des classes
print(D.TYPE.value_counts())
```

    lodgepole     283301
    spruce        211840
    ponderosa      35754
    krummholz      20510
    douglas        17367
    aspen           9493
    cottonwood      2747
    Name: TYPE, dtype: int64
    


```python
#extraire un échantillon pour l'apprentissage, le reste pour le test
DS, DT = train_test_split(D,train_size=20000,random_state=0)
print(DS.shape)
print(DT.shape)
```

    (20000, 55)
    (561012, 55)
    


```python
#***********************
#régression multinomiale
lr = LogisticRegression(multi_class='multinomial',solver='newton-cg')

#apprentissage
%time lr.fit(DS.iloc[:,:-1],DS.TYPE)

#vérification
pred = lr.predict(DT.iloc[:,:-1])

#taux d'erreur
print(numpy.mean(DT.TYPE != pred))
```

    D:\Logiciels\Anaconda3\lib\site-packages\sklearn\utils\optimize.py:211: ConvergenceWarning: newton-cg failed to converge. Increase the number of iterations.
      warnings.warn("newton-cg failed to converge. Increase the "
    

    Wall time: 44.6 s
    0.28357147440696456
    


```python
#**************************************************************
#centrer et réduire les données pour la régression multinomiale
from sklearn.preprocessing import StandardScaler
std = StandardScaler()

#centrer et réduire
ZS = std.fit_transform(DS.iloc[:,:-1])

#régression multinomiale
lr = LogisticRegression(multi_class='multinomial',solver='newton-cg')

#apprentissage
%time lr.fit(ZS,DS.TYPE)

#vérification
pred = lr.predict(std.transform(DT.iloc[:,:-1]))

#taux d'erreur
print(numpy.mean(DT.TYPE != pred))
```

    Wall time: 10.9 s
    0.27751991044754837
    


```python
#*****************************************************************
#régressions multinomiale avec saga -- données centrées et réduite
lr = LogisticRegression(multi_class='multinomial',solver='saga')

#apprentissage
%time lr.fit(ZS,DS.TYPE)

#vérification
pred = lr.predict(std.transform(DT.iloc[:,:-1]))

#taux d'erreur
print(numpy.mean(DT.TYPE != pred))
```

    D:\Logiciels\Anaconda3\lib\site-packages\sklearn\linear_model\_sag.py:329: ConvergenceWarning: The max_iter was reached which means the coef_ did not converge
      warnings.warn("The max_iter was reached which means "
    

    Wall time: 8.97 s
    0.28086208494648957
    


```python
#*****************************************
#régressions binaires "ovr" avec liblinear
lr = LogisticRegression(multi_class='ovr',solver='liblinear')

#apprentissage
%time lr.fit(DS.iloc[:,:-1],DS.TYPE)

#vérification
pred = lr.predict(DT.iloc[:,:-1])

#taux d'erreur
print(numpy.mean(DT.TYPE != pred))
```

    Wall time: 2.47 s
    0.2909403007422301
    


```python

```
